/**
* Copyright (c) 2019 The Nuinalp Authors. All rights reserved.
* Use of this source code is governed by a BSD-style license that can be
* found in the LICENSE file.
*/
$spinner-duration: 1.2s;

:host {
  --size: 40px;

  background-color: transparent;
  display: block;
  font-size: var(--size);
  height: 1em;
  margin: $space-sm;
  position: relative;
  width: 1em;

  // Circles
  &::before,
  &::after {
    animation: spinner-animation $spinner-duration infinite;
    animation-fill-mode: backwards;
    border: 4px solid;
    border-radius: 1em;
    content: '';
    height: inherit;
    left: -2px;
    position: absolute;
    top: -2px;
    width: inherit;
    z-index: 10;
  }

  &::before {
    border-color: var(--nv-theme-primary) transparent transparent transparent;
  }

  &::after {
    animation-delay: $spinner-duration / 2;
    border-color: transparent var(--nv-theme-primary-dark) transparent transparent;
  }
}

:host(.nv-loader-anim-paused) {
  &::before,
  &::after {
    animation-play-state: paused;
  }
}

//
// Sizes
//

:host(.nv-loader-small) {
  font-size: 20px;

  &::before,
  &::after {
    border-width: 2px;
  }
}

:host(.nv-loader-medium) {
  font-size: 40px;
}

:host(.nv-loader-large) {
  font-size: 60px;
}

:host(.nv-loader-big) {
  font-size: 80px;
}

//
// Animations
//

@keyframes spinner-animation {
  0% {
    animation-timing-function: cubic-bezier(0, 0, 0.8, 0.2);
    transform: rotateZ(0deg);
  }

  50% {
    animation-timing-function: cubic-bezier(0.2, 0.8, 1, 1);
    transform: rotateZ(180deg);
  }

  100% {
    transform: rotateZ(360deg);
  }
}
